---
title: MediaStreamTrackAudioSourceNode()
slug: Web/API/MediaStreamTrackAudioSourceNode/MediaStreamTrackAudioSourceNode
tags:
  - API
  - Audio
  - AudioSource
  - Interface
  - Media
  - MediaStreamTrack
  - MediaStreamTrackAudioSourceNode
  - Node
  - Reference
  - Web Audio
  - Web Audio API
  - sound
  - source
  - track
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>'s <code><strong>MediaStreamTrackAudioSourceNode()</strong></code> constructor creates and returns a new {{domxref("MediaStreamTrackAudioSourceNode")}} object whose audio is taken from the {{domxref("MediaStreamTrack")}} specified in the given options object.</span></p>

<p>Another way to create a <code>MediaStreamTrackAudioSourceNode</code> is to call the{{domxref("AudioContext.createMediaStreamTrackSource()")}} method, specifying the {{domxref("MediaStreamTrack")}}  from which you want to obtain audio.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>audioTrackNode</em> = new MediaStreamTrackAudioSourceNode(<em>context</em>, <em>options</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>context</code></dt>
 <dd>An {{domxref("AudioContext")}} representing the audio context you want the node to be associated with.</dd>
 <dt><code>options</code></dt>
 <dd>
 <p>A {{domxref("MediaStreamTrackAudioSourceOptions")}} object defining the properties you want the <code>MediaStreamTrackAudioSourceNode</code> to have:</p>

 <p>{{page("/en-US/docs/Web/API/MediaStreamTrackAudioSourceOptions", "Properties")}}</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("MediaStreamTrackAudioSourceNode")}} object representing the audio node whose media is obtained from the specified media track.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>The specified <code>context</code> is not an {{domxref("AudioContext")}}.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The specified {{domxref("MediaStreamTrack")}} isn't an audio track (that is, its {{domxref("MediaStreamTrack.kind", "kind")}} property isn't <code>audio</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example uses {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain access to the user's camera, then creates a new {{domxref("MediaStreamAudioSourceNode")}} from the first audio track provided by the device.</p>

<pre class="brush: js">let audioCtx = new (window.AudioContext || window.webkitAudioContext)();

if (navigator.mediaDevices.getUserMedia) {
  navigator.mediaDevices.getUserMedia (
    {
      audio: true,
      video: false
    }).then(function(stream) {
      let options = {
        mediaStreamTrack: stream.getAudioTracks()[0];
      }

      let source = new MediaStreamTrackAudioSourceNode(audioCtx, options);
      source.connect(audioCtx.destination);
    }).catch(function(err) {
      console.log('The following gUM error occurred: ' + err);
    });
} else {
  console.log('new getUserMedia not supported on your browser!');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API','#dom-mediastreamtrackaudiosourcenode-mediastreamtrackaudiosourcenode','MediaStreamTrackAudioSourceNode()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrackAudioSourceNode.MediaStreamTrackAudioSourceNode")}}</p>
